#ifndef THREAD_H
#define THREAD_H

class mutex{
    pthread_mutex_t mut;
    public:
    mutex(){
        pthread_mutex_init(&mut, NULL); 
    }
    void lock(){
        pthread_mutex_lock(&mut);
    }
    void unlock(){
        pthread_mutex_unlock(&mut);
    }
    
};

#define ThreadExit pthread_exit(NULL)

class Thread{
    pthread_t t;
    
    public:
    
    Thread(){}
    
    bool run(void* fun(void* ),void* args = NULL){
        int rc = pthread_create(&t,NULL,fun,args);
        if(rc){
            cout << "Error in thread creation number " << rc << endl;
            return false;
        }
        return true;
    }
    
    void* join(){
        void* status;
        pthread_join(t, &status);
        return status;
    }
};

#endif