#!/usr/bin/env python

import sys

src = open(sys.argv[1])
dst = open(sys.argv[2],"w")

lines = src.readlines()

dst.write('<link rel="stylesheet" href="styles/default.css"><script src="highlight.pack.js"></script><script>hljs.initHighlightingOnLoad();</script>')

for a in range(len(lines)):
	line = lines[a]

	if line[-1] == "\n": line = line[:-1]
	
	if line == "":
		dst.write("<br>")
		continue

	title = 0
	while line[title] == "=":
		title = title + 1
	if title > 0:
		line = line[title:]
		dst.write("<h"+str(4-title)+">"+line+"</h"+str(4-title)+">")
		continue

	if line[0:3] == "{{{":
		dst.write("<code>")
		continue

	if line[0:3] == "}}}":
		dst.write("</code>")
		continue		

	dst.write(line+"<br>")
