var fs = require("fs");
var roshFolder = "..";

Array.prototype.diff = function(a) {
    return this.filter(function(i) {return !(a.indexOf(i) > -1);});
};


function recursiveForEach(arr,i,cb){
	cb(arr[i]);
	if(i == arr.length-1)return;
	recursiveForEach(arr,i+1,cb);
}

function forEach(arr,cb){
	recursiveForEach(arr,0,cb);
}

var easy = require('./easy');

exports.nodes = [];

function Progam(name){
	this.name = name;
    easy.parse(fs.readFileSync(roshFolder+"/"+name+"/manifest"),this);
    if(fs.existsSync(roshFolder+"/"+name+"/settings")){
        easy.parse(fs.readFileSync(roshFolder+"/"+name+"/settings"),this,function(line){
            var parts = line.split(",");
            var res = {};
            res.name = parts[0];
            res.type = parts[1];
            res.default = parts[2];
            return res;
        });
    }
}


exports.init = function(){
	var p = fs.readdirSync(roshFolder).diff(["node","Include","README.md"]);
    for (var i = 0; i < p.length; i++){
		if(fs.existsSync(roshFolder+"/"+p[i]+"/manifest"))exports.nodes.push(new Progam(p[i]));
    }
    return exports;
}