#include "../Include/roshbot.h"
#include <iostream>



using namespace std;

//input port, out port, height
int main(int argc,char** argv){
	sharedMemoryInit();
	SharedMemClient depth(atoi(argv[1]),sizeof(float)*640*480*3);
	SharedMemServer line(atoi(argv[2]),sizeof(float)*640*3);
    Mat d(480,640,CV_32FC3,depth.shm);

    float h = -atof(argv[3]);
	
	float* res = (float*)line.shm;
	float max = 3.0;

	while(1){
		depth.wait();
		for(int a = 0;a < 640;a++){
			res[a*3+2] = 3.0;
			for(int b = 0;b < 480;b++){
				float* ptr = (float*)d.ptr(b);
				if(ptr[a*3+2] > 0.0 && ptr[a*3+1] > h && ptr[a*3+2] < res[a*3+2]){
					res[a*3+2] = ptr[a*3+2];
					res[a*3] = ptr[a*3];
				}
			}
		}
		line.send();
	}

	return 0;
}