#ifndef MATH_H
#define MATH_H

#include <math.h>

#define PI 3.14159265359

template<class t>t Abs(t a){
    return(a>0)?a:-a;
}

template<class t>bool compareSign(const t& a,const t& b){
    return signbit(a) == signbit(b);
}

template<class t>t signedSquare(t a){
	if(a > 0)return pow(a,2.0);
	else return -pow(a,2.0);
}
#endif
