#include "../Include/roshbot.h"
#include <iostream>



using namespace std;

//line position map particles motionError senseError
int main(int argc,char** argv){
    sharedMemoryInit();
    SharedMemClient line(atoi(argv[1]),sizeof(float)*640*3);
    SharedMemServer position(atoi(argv[2]),sizeof(float)*3);
    float* pos = (float*)position.shm;

    Space p("plot",800,800);
    cout << "Up and running\n";

    kinectLineLocalization localization(&p,argv[3],atoi(argv[4]),float(atof(argv[5])),float(atof(argv[6])));

    while(1){
        //get frame
        line.wait();
        
        localization.getLine((float*)line.shm);
        float* agent = localization.update();
        pos[0] = agent[0]; pos[1] = agent[1]; pos[2] = agent[2];
        position.send();
        //cout << "a\n";
        if(!p.draw())break;
    }
}